﻿'Programmer: Seth McNamee
'Project: CPT 212 Lab 6
'Purpose: Create a project which allows a user to input an item name, quantity desired, weight, price, and state (two letter state abbreviation) To ship the order. Calculates the subtotal and total with shipping, handling, and sales tax if in california
'         An order may consist of one or more items, but the ship to state is only available when entering the first item. Once the user enters the first item they cannot change the ship To state.

Option Explicit On
Option Strict On
Public Class frmMailOrder
    Dim intTotalWeight As Integer = 0
    Dim decSubTotal As Decimal = 0.0D
    Private Function SalesTax(ByVal decPrice As Decimal, ByVal strState As String) As Decimal
        'Checks to see if the state is the abbreciation of California and if it is then adds an 8% sales tax
        Const str_CALIFORNIA_STATE_ABREVIATION As String = "CA"
        Const dec_SALES_TAX_RATE As Decimal = 0.08D
        Dim decSalesTax As Decimal = 0.0D

        If strState.ToUpper = str_CALIFORNIA_STATE_ABREVIATION Then
            decSalesTax = decPrice * dec_SALES_TAX_RATE
        End If


        Return decSalesTax

    End Function

    Private Function ShippingHandling(ByVal intWeight As Integer) As Decimal
        'calculates the shipping and handling fees
        Const dec_SHIPPING As Decimal = 0.25D
        Dim decShippingHandling As Decimal = 0.0D

        decShippingHandling = CDec(intWeight) * dec_SHIPPING

        If intWeight < 10 Then
            decShippingHandling += 1D
        ElseIf intWeight >= 10 And intWeight <= 100 Then
            decShippingHandling += 3D
        ElseIf intWeight > 100 Then
            decShippingHandling += 5D
        End If

        Return decShippingHandling

    End Function


    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        'closes the program
        Me.Close()
    End Sub

    Private Sub btnClearItem_Click(sender As Object, e As EventArgs) Handles btnClearItem.Click
        'clears the textboxes and resets the focus
        txtItemName.Text = ""
        txtPrice.Text = ""
        txtQuantityDesired.Text = ""
        txtWeight.Text = ""
        txtItemName.Focus()
    End Sub

    Private Sub btnNewOrder_Click(sender As Object, e As EventArgs) Handles btnNewOrder.Click
        'resets the entire order
        Dim whichButtonDialogResult As DialogResult

        whichButtonDialogResult = MessageBox.Show("Clear the current order?", "Clear Order", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)

        If whichButtonDialogResult = DialogResult.Yes Then
            txtState.Text = ""
            txtState.Enabled = True
            Call btnClearItem_Click(sender, e)
            decSubTotal = 0.0D
            intTotalWeight = 0
        End If
    End Sub

    Private Sub btnAddItem_Click(sender As Object, e As EventArgs) Handles btnAddItem.Click
        'Validates the input and calculates the charge for the current item.
        'Adds the weight to the total order weight And adds the charge to the total order charge. 
        If txtItemName.Text = "" Then
            MessageBox.Show("Please Enter an Item Name", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf txtQuantityDesired.Text = "" Then
            MessageBox.Show("Please Enter The Amount of items you want to ship", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf Not IsNumeric(txtQuantityDesired.Text) Then
            MessageBox.Show("Please Enter a Numeric Number in Quantity Desired", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtQuantityDesired.Text = ""
        ElseIf Math.Floor(CSng(txtQuantityDesired.Text)) <> Math.Ceiling(CSng(txtQuantityDesired.Text)) Then
            MessageBox.Show("Please Enter a Whole Numeric Number in Quantity Desired", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtQuantityDesired.Text = ""
        ElseIf CInt(txtQuantityDesired.Text) <= 0 Then
            MessageBox.Show("Please Enter a positive numeric number in Quantity Desired", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtQuantityDesired.Text = ""
        ElseIf txtWeight.Text = "" Then
            MessageBox.Show("Please Enter a Weight", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf Not IsNumeric(txtWeight.Text) Then
            MessageBox.Show("Please Enter a numeric number for the Weight", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtWeight.Text = ""
        ElseIf CDec(txtWeight.Text) <= 0 Then
            MessageBox.Show("Please Enter a Positive numeric number for the Weight", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtWeight.Text = ""
        ElseIf txtPrice.Text = "" Then
            MessageBox.Show("Please Enter a Price", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf Not IsNumeric(txtPrice.Text) Then
            MessageBox.Show("Please Enter a Numeric Number as the Price", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtPrice.Text = ""
        ElseIf CDec(txtPrice.Text) <= 0 Then
            MessageBox.Show("Please Enter a Positive Numeric Number as the Price", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtPrice.Text = ""
        ElseIf txtState.Text = "" Then
            MessageBox.Show("Please Enter a Two letter abreviation for the State", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)

        ElseIf Len(txtState.Text) > 2 Then
            MessageBox.Show("Please Enter a Two letter abreviation for the State", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtState.Text = ""
        ElseIf IsNumeric(txtState.Text) Then
            MessageBox.Show("Please Enter a Two letter abreviation for the State", "Invalid Input", MessageBoxButtons.OK, MessageBoxIcon.Error)
            txtState.Text = ""
        Else
            decSubTotal += CDec(txtQuantityDesired.Text) * CDec(txtPrice.Text)
            intTotalWeight += CInt(txtWeight.Text) * CInt(txtQuantityDesired.Text)


            txtState.Enabled = False
        End If

    End Sub

    Private Sub btnCompleteOrder_Click(sender As Object, e As EventArgs) Handles btnCompleteOrder.Click
        'Calculates the order total with a breakdown of the subtotals.
        'Calls a function to calculate sales tax for orders shipped within California.
        'Calls a second function to calculate shipping And handling.
        'Displays the subtotal amount due, sales tax, shipping And handling, And total amount due On a separate Order Complete Form. 

        Dim decSalesTax As Decimal = 0.0D
        Dim decTotal As Decimal = 0.0D
        Dim decShippingAndHandling As Decimal = 0.0D
        Dim strState As String = ""
        Dim frmOrderComplete As New frmOrderComplete

        strState = txtState.Text


        decSalesTax = SalesTax(decSubTotal, strState)


        decShippingAndHandling = ShippingHandling(intTotalWeight)

        decTotal = decSubTotal + decSalesTax + decShippingAndHandling




        frmOrderComplete.lblSubTotal.Text = decSubTotal.ToString("C")
        frmOrderComplete.lblSalesTax.Text = decSalesTax.ToString("C")
        frmOrderComplete.lblShippingAndHandling.Text = decShippingAndHandling.ToString("C")
        frmOrderComplete.lblTotal.Text = decTotal.ToString("C")
        frmOrderComplete.Show()

    End Sub
End Class
